blob: c2eebee798d10f7ed5977fc4e56cf02731031971 [file] [log] [blame]
Linus Torvalds7ef76922005-05-22 11:03:24 -07001#!/bin/sh
2#
freku045@student.liu.se87358b72005-12-13 23:30:31 +01003
4USAGE='<fetch-options> <repository> <refspec>...'
Junio C Hamanoae2b0f12005-11-24 00:12:11 -08005. git-sh-setup
Junio C Hamano215a7ad2005-09-07 17:26:23 -07006. git-parse-remote
Junio C Hamano853a3692005-08-20 02:54:34 -07007_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
8_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
Linus Torvaldsb33e9662005-07-08 10:57:21 -07009
Junio C Hamano221e7432005-10-10 23:22:02 -070010LF='
11'
12IFS="$LF"
13
Shawn Pearce55b78352006-07-10 23:38:35 -040014rloga=fetch
Junio C Hamano03febf92006-01-07 00:48:04 -080015no_tags=
Linus Torvaldsed1aadf2005-09-29 14:35:15 -070016tags=
Junio C Hamano853a3692005-08-20 02:54:34 -070017append=
Junio C Hamanoae2da402005-08-22 21:28:33 -070018force=
Linus Torvalds583122c2005-11-18 08:31:55 -080019verbose=
Junio C Hamanob10ac502005-08-25 18:15:32 -070020update_head_ok=
Michal Ostrowski2c620a12006-01-20 13:05:24 -050021exec=
Michal Ostrowski96b086d2006-01-20 13:38:16 -050022upload_pack=
Junio C Hamano482faa82006-07-17 13:01:27 -070023keep=--thin
Junio C Hamanoae2da402005-08-22 21:28:33 -070024while case "$#" in 0) break ;; esac
25do
26 case "$1" in
27 -a|--a|--ap|--app|--appe|--appen|--append)
28 append=t
Junio C Hamanoae2da402005-08-22 21:28:33 -070029 ;;
Junio C Hamano2796a9d2006-01-26 18:11:06 -080030 --upl|--uplo|--uploa|--upload|--upload-|--upload-p|\
31 --upload-pa|--upload-pac|--upload-pack)
Michal Ostrowski2c620a12006-01-20 13:05:24 -050032 shift
33 exec="--exec=$1"
Michal Ostrowski96b086d2006-01-20 13:38:16 -050034 upload_pack="-u $1"
Michal Ostrowski2c620a12006-01-20 13:05:24 -050035 ;;
Junio C Hamanoae2da402005-08-22 21:28:33 -070036 -f|--f|--fo|--for|--forc|--force)
37 force=t
Junio C Hamanob10ac502005-08-25 18:15:32 -070038 ;;
Linus Torvaldsed1aadf2005-09-29 14:35:15 -070039 -t|--t|--ta|--tag|--tags)
40 tags=t
41 ;;
Junio C Hamano03febf92006-01-07 00:48:04 -080042 -n|--n|--no|--no-|--no-t|--no-ta|--no-tag|--no-tags)
43 no_tags=t
44 ;;
Junio C Hamanob10ac502005-08-25 18:15:32 -070045 -u|--u|--up|--upd|--upda|--updat|--update|--update-|--update-h|\
46 --update-he|--update-hea|--update-head|--update-head-|\
47 --update-head-o|--update-head-ok)
48 update_head_ok=t
Junio C Hamanoae2da402005-08-22 21:28:33 -070049 ;;
Linus Torvalds583122c2005-11-18 08:31:55 -080050 -v|--verbose)
51 verbose=Yes
52 ;;
Tom Prince0f76f522006-01-10 18:50:19 -070053 -k|--k|--ke|--kee|--keep)
54 keep=--keep
55 ;;
Shawn Pearce55b78352006-07-10 23:38:35 -040056 --reflog-action=*)
57 rloga=`expr "z$1" : 'z-[^=]*=\(.*\)'`
58 ;;
freku045@student.liu.se87358b72005-12-13 23:30:31 +010059 -*)
60 usage
61 ;;
Junio C Hamanoae2da402005-08-22 21:28:33 -070062 *)
63 break
64 ;;
65 esac
Junio C Hamanob10ac502005-08-25 18:15:32 -070066 shift
Junio C Hamanoae2da402005-08-22 21:28:33 -070067done
68
Junio C Hamano853a3692005-08-20 02:54:34 -070069case "$#" in
700)
Junio C Hamano92c533e2005-08-20 03:00:03 -070071 test -f "$GIT_DIR/branches/origin" ||
72 test -f "$GIT_DIR/remotes/origin" ||
Santi Béjar5e27e272006-07-23 00:54:40 +020073 git-repo-config --get remote.origin.url >/dev/null ||
74 die "Where do you want to fetch from today?"
Junio C Hamano92c533e2005-08-20 03:00:03 -070075 set origin ;;
Junio C Hamano853a3692005-08-20 02:54:34 -070076esac
Junio C Hamanoae2da402005-08-22 21:28:33 -070077
Junio C Hamano853a3692005-08-20 02:54:34 -070078remote_nick="$1"
79remote=$(get_remote_url "$@")
80refs=
81rref=
82rsync_slurped_objects=
Linus Torvalds7ef76922005-05-22 11:03:24 -070083
Shawn Pearce55b78352006-07-10 23:38:35 -040084rloga="$rloga $remote_nick"
Eric Wonged0e0782006-07-11 14:06:39 -070085test "$remote_nick" = "$remote" || rloga="$rloga $remote"
Shawn Pearce55b78352006-07-10 23:38:35 -040086
Junio C Hamano853a3692005-08-20 02:54:34 -070087if test "" = "$append"
88then
Santi_Béjardf342972005-10-05 18:58:10 +020089 : >"$GIT_DIR/FETCH_HEAD"
Junio C Hamano853a3692005-08-20 02:54:34 -070090fi
91
92append_fetch_head () {
93 head_="$1"
94 remote_="$2"
95 remote_name_="$3"
96 remote_nick_="$4"
97 local_name_="$5"
Junio C Hamano05dd8e22005-09-25 22:54:23 -070098 case "$6" in
99 t) not_for_merge_='not-for-merge' ;;
100 '') not_for_merge_= ;;
101 esac
Junio C Hamano853a3692005-08-20 02:54:34 -0700102
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700103 # remote-nick is the URL given on the command line (or a shorthand)
104 # remote-name is the $GIT_DIR relative refs/ path we computed
105 # for this refspec.
Eric Wong687b8be2006-03-10 04:19:07 -0800106
107 # the $note_ variable will be fed to git-fmt-merge-msg for further
108 # processing.
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700109 case "$remote_name_" in
110 HEAD)
111 note_= ;;
112 refs/heads/*)
113 note_="$(expr "$remote_name_" : 'refs/heads/\(.*\)')"
Junio C Hamanob91fb512005-09-21 13:59:54 -0700114 note_="branch '$note_' of " ;;
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700115 refs/tags/*)
116 note_="$(expr "$remote_name_" : 'refs/tags/\(.*\)')"
Junio C Hamanob91fb512005-09-21 13:59:54 -0700117 note_="tag '$note_' of " ;;
Eric Wong687b8be2006-03-10 04:19:07 -0800118 refs/remotes/*)
119 note_="$(expr "$remote_name_" : 'refs/remotes/\(.*\)')"
120 note_="remote branch '$note_' of " ;;
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700121 *)
Junio C Hamanob91fb512005-09-21 13:59:54 -0700122 note_="$remote_name of " ;;
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700123 esac
Mark Woodingf327dbc2006-04-13 22:01:24 +0000124 remote_1_=$(expr "z$remote_" : 'z\(.*\)\.git/*$') &&
Junio C Hamanob91fb512005-09-21 13:59:54 -0700125 remote_="$remote_1_"
126 note_="$note_$remote_"
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700127
Junio C Hamano853a3692005-08-20 02:54:34 -0700128 # 2.6.11-tree tag would not be happy to be fed to resolve.
129 if git-cat-file commit "$head_" >/dev/null 2>&1
130 then
Junio C Hamano8572aa82005-08-24 22:46:07 -0700131 headc_=$(git-rev-parse --verify "$head_^0") || exit
Santi_Béjardf342972005-10-05 18:58:10 +0200132 echo "$headc_ $not_for_merge_ $note_" >>"$GIT_DIR/FETCH_HEAD"
Linus Torvalds583122c2005-11-18 08:31:55 -0800133 [ "$verbose" ] && echo >&2 "* committish: $head_"
134 [ "$verbose" ] && echo >&2 " $note_"
Junio C Hamano853a3692005-08-20 02:54:34 -0700135 else
Santi_Béjardf342972005-10-05 18:58:10 +0200136 echo "$head_ not-for-merge $note_" >>"$GIT_DIR/FETCH_HEAD"
Linus Torvalds583122c2005-11-18 08:31:55 -0800137 [ "$verbose" ] && echo >&2 "* non-commit: $head_"
138 [ "$verbose" ] && echo >&2 " $note_"
Junio C Hamano853a3692005-08-20 02:54:34 -0700139 fi
140 if test "$local_name_" != ""
141 then
142 # We are storing the head locally. Make sure that it is
143 # a fast forward (aka "reverse push").
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700144 fast_forward_local "$local_name_" "$head_" "$note_"
Junio C Hamano853a3692005-08-20 02:54:34 -0700145 fi
146}
147
148fast_forward_local () {
Junio C Hamano866ff2f2005-09-10 10:40:47 -0700149 mkdir -p "$(dirname "$GIT_DIR/$1")"
Junio C Hamano853a3692005-08-20 02:54:34 -0700150 case "$1" in
151 refs/tags/*)
152 # Tags need not be pointing at commits so there
153 # is no way to guarantee "fast-forward" anyway.
Junio C Hamanoae2da402005-08-22 21:28:33 -0700154 if test -f "$GIT_DIR/$1"
155 then
Junio C Hamanof8765792005-10-18 18:42:14 -0700156 if now_=$(cat "$GIT_DIR/$1") && test "$now_" = "$2"
157 then
Sergey Vlasov7eae7b92006-07-14 19:06:57 +0400158 [ "$verbose" ] && echo >&2 "* $1: same as $3" ||:
Junio C Hamanof8765792005-10-18 18:42:14 -0700159 else
160 echo >&2 "* $1: updating with $3"
Shawn Pearce55b78352006-07-10 23:38:35 -0400161 git-update-ref -m "$rloga: updating tag" "$1" "$2"
Junio C Hamanof8765792005-10-18 18:42:14 -0700162 fi
Junio C Hamanoae2da402005-08-22 21:28:33 -0700163 else
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700164 echo >&2 "* $1: storing $3"
Shawn Pearce55b78352006-07-10 23:38:35 -0400165 git-update-ref -m "$rloga: storing tag" "$1" "$2"
Junio C Hamanoae2da402005-08-22 21:28:33 -0700166 fi
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700167 ;;
Junio C Hamanoae2da402005-08-22 21:28:33 -0700168
Eric Wong687b8be2006-03-10 04:19:07 -0800169 refs/heads/* | refs/remotes/*)
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700170 # $1 is the ref being updated.
171 # $2 is the new value for the ref.
172 local=$(git-rev-parse --verify "$1^0" 2>/dev/null)
173 if test "$local"
Junio C Hamano853a3692005-08-20 02:54:34 -0700174 then
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700175 # Require fast-forward.
Junio C Hamano853a3692005-08-20 02:54:34 -0700176 mb=$(git-merge-base "$local" "$2") &&
177 case "$2,$mb" in
178 $local,*)
Junio C Hamanoea5aeb02006-06-03 23:44:40 -0700179 if test -n "$verbose"
180 then
181 echo >&2 "* $1: same as $3"
182 fi
Junio C Hamano853a3692005-08-20 02:54:34 -0700183 ;;
184 *,$local)
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700185 echo >&2 "* $1: fast forward to $3"
Lukas Sandström9d7f73d2006-02-25 12:20:13 +0100186 echo >&2 " from $local to $2"
Shawn Pearce55b78352006-07-10 23:38:35 -0400187 git-update-ref -m "$rloga: fast-forward" "$1" "$2" "$local"
Junio C Hamano853a3692005-08-20 02:54:34 -0700188 ;;
189 *)
190 false
191 ;;
192 esac || {
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700193 echo >&2 "* $1: does not fast forward to $3;"
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700194 case ",$force,$single_force," in
195 *,t,*)
Junio C Hamano06ec2b42005-09-02 02:34:13 -0700196 echo >&2 " forcing update."
Shawn Pearce55b78352006-07-10 23:38:35 -0400197 git-update-ref -m "$rloga: forced-update" "$1" "$2" "$local"
Junio C Hamanoae2da402005-08-22 21:28:33 -0700198 ;;
199 *)
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700200 echo >&2 " not updating."
Junio C Hamanoa9698bb2006-03-16 22:04:18 -0800201 exit 1
Junio C Hamanoae2da402005-08-22 21:28:33 -0700202 ;;
203 esac
Junio C Hamano853a3692005-08-20 02:54:34 -0700204 }
205 else
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700206 echo >&2 "* $1: storing $3"
Shawn Pearce55b78352006-07-10 23:38:35 -0400207 git-update-ref -m "$rloga: storing head" "$1" "$2"
Junio C Hamano853a3692005-08-20 02:54:34 -0700208 fi
Linus Torvalds0a623e72005-07-05 11:38:37 -0700209 ;;
Junio C Hamano853a3692005-08-20 02:54:34 -0700210 esac
211}
212
Junio C Hamanob10ac502005-08-25 18:15:32 -0700213case "$update_head_ok" in
214'')
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700215 orig_head=$(git-rev-parse --verify HEAD 2>/dev/null)
Junio C Hamanob10ac502005-08-25 18:15:32 -0700216 ;;
217esac
218
Linus Torvaldsed1aadf2005-09-29 14:35:15 -0700219# If --tags (and later --heads or --all) is specified, then we are
220# not talking about defaults stored in Pull: line of remotes or
221# branches file, and just fetch those and refspecs explicitly given.
222# Otherwise we do what we always did.
223
224reflist=$(get_remote_refs_for_fetch "$@")
225if test "$tags"
226then
Junio C Hamano878ccb22006-05-28 19:24:28 -0700227 taglist=`IFS=" " &&
Junio C Hamano57a39692006-07-10 03:34:34 -0700228 (
229 git-ls-remote $upload_pack --tags "$remote" ||
230 echo fail ouch
231 ) |
Junio C Hamano81214e42006-01-05 19:42:12 -0800232 while read sha1 name
233 do
Junio C Hamano57a39692006-07-10 03:34:34 -0700234 case "$sha1" in
235 fail)
236 exit 1
237 esac
Junio C Hamano81214e42006-01-05 19:42:12 -0800238 case "$name" in
Junio C Hamano878ccb22006-05-28 19:24:28 -0700239 *^*) continue ;;
Junio C Hamano81214e42006-01-05 19:42:12 -0800240 esac
241 if git-check-ref-format "$name"
242 then
243 echo ".${name}:${name}"
244 else
245 echo >&2 "warning: tag ${name} ignored"
246 fi
Junio C Hamano57a39692006-07-10 03:34:34 -0700247 done` || exit
Linus Torvaldsed1aadf2005-09-29 14:35:15 -0700248 if test "$#" -gt 1
249 then
250 # remote URL plus explicit refspecs; we need to merge them.
Junio C Hamano221e7432005-10-10 23:22:02 -0700251 reflist="$reflist$LF$taglist"
Linus Torvaldsed1aadf2005-09-29 14:35:15 -0700252 else
253 # No explicit refspecs; fetch tags only.
254 reflist=$taglist
255 fi
256fi
257
Junio C Hamano03febf92006-01-07 00:48:04 -0800258fetch_main () {
259 reflist="$1"
260 refs=
Junio C Hamano853a3692005-08-20 02:54:34 -0700261
Junio C Hamano03febf92006-01-07 00:48:04 -0800262 for ref in $reflist
263 do
264 refs="$refs$LF$ref"
Junio C Hamano853a3692005-08-20 02:54:34 -0700265
Junio C Hamano03febf92006-01-07 00:48:04 -0800266 # These are relative path from $GIT_DIR, typically starting at refs/
267 # but may be HEAD
Mark Woodingf327dbc2006-04-13 22:01:24 +0000268 if expr "z$ref" : 'z\.' >/dev/null
Junio C Hamano03febf92006-01-07 00:48:04 -0800269 then
270 not_for_merge=t
Mark Woodingf327dbc2006-04-13 22:01:24 +0000271 ref=$(expr "z$ref" : 'z\.\(.*\)')
Junio C Hamano03febf92006-01-07 00:48:04 -0800272 else
273 not_for_merge=
274 fi
Junio C Hamanodfdcb552006-04-13 19:05:38 -0700275 if expr "z$ref" : 'z+' >/dev/null
Junio C Hamano03febf92006-01-07 00:48:04 -0800276 then
277 single_force=t
Junio C Hamanodfdcb552006-04-13 19:05:38 -0700278 ref=$(expr "z$ref" : 'z+\(.*\)')
Junio C Hamano03febf92006-01-07 00:48:04 -0800279 else
280 single_force=
281 fi
Mark Woodingf327dbc2006-04-13 22:01:24 +0000282 remote_name=$(expr "z$ref" : 'z\([^:]*\):')
283 local_name=$(expr "z$ref" : 'z[^:]*:\(.*\)')
Junio C Hamano853a3692005-08-20 02:54:34 -0700284
Junio C Hamano03febf92006-01-07 00:48:04 -0800285 rref="$rref$LF$remote_name"
Junio C Hamano4447bad2005-09-17 11:56:41 -0700286
Junio C Hamano03febf92006-01-07 00:48:04 -0800287 # There are transports that can fetch only one head at a time...
288 case "$remote" in
289 http://* | https://*)
290 if [ -n "$GIT_SSL_NO_VERIFY" ]; then
291 curl_extra_args="-k"
292 fi
Nick Hengeveld093b0682006-04-26 09:10:01 -0700293 max_depth=5
294 depth=0
295 head="ref: $remote_name"
296 while (expr "z$head" : "zref:" && expr $depth \< $max_depth) >/dev/null
297 do
Michal Rokosd9bffc02006-07-08 17:32:04 +0200298 remote_name_quoted=$(@@PERL@@ -e '
Junio C Hamano03febf92006-01-07 00:48:04 -0800299 my $u = $ARGV[0];
Nick Hengeveld093b0682006-04-26 09:10:01 -0700300 $u =~ s/^ref:\s*//;
Junio C Hamano03febf92006-01-07 00:48:04 -0800301 $u =~ s{([^-a-zA-Z0-9/.])}{sprintf"%%%02x",ord($1)}eg;
302 print "$u";
Nick Hengeveld093b0682006-04-26 09:10:01 -0700303 ' "$head")
304 head=$(curl -nsfL $curl_extra_args "$remote/$remote_name_quoted")
305 depth=$( expr \( $depth + 1 \) )
306 done
Mark Woodingf327dbc2006-04-13 22:01:24 +0000307 expr "z$head" : "z$_x40\$" >/dev/null ||
Nick Hengeveld093b0682006-04-26 09:10:01 -0700308 die "Failed to fetch $remote_name from $remote"
Junio C Hamano03febf92006-01-07 00:48:04 -0800309 echo >&2 Fetching "$remote_name from $remote" using http
310 git-http-fetch -v -a "$head" "$remote/" || exit
311 ;;
312 rsync://*)
313 TMP_HEAD="$GIT_DIR/TMP_HEAD"
314 rsync -L -q "$remote/$remote_name" "$TMP_HEAD" || exit 1
315 head=$(git-rev-parse --verify TMP_HEAD)
316 rm -f "$TMP_HEAD"
317 test "$rsync_slurped_objects" || {
318 rsync -av --ignore-existing --exclude info \
319 "$remote/objects/" "$GIT_OBJECT_DIRECTORY/" || exit
Junio C Hamano853a3692005-08-20 02:54:34 -0700320
Junio C Hamano03febf92006-01-07 00:48:04 -0800321 # Look at objects/info/alternates for rsync -- http will
322 # support it natively and git native ones will do it on
323 # the remote end. Not having that file is not a crime.
324 rsync -q "$remote/objects/info/alternates" \
325 "$GIT_DIR/TMP_ALT" 2>/dev/null ||
326 rm -f "$GIT_DIR/TMP_ALT"
327 if test -f "$GIT_DIR/TMP_ALT"
328 then
329 resolve_alternates "$remote" <"$GIT_DIR/TMP_ALT" |
330 while read alt
331 do
332 case "$alt" in 'bad alternate: '*) die "$alt";; esac
333 echo >&2 "Getting alternate: $alt"
334 rsync -av --ignore-existing --exclude info \
335 "$alt" "$GIT_OBJECT_DIRECTORY/" || exit
336 done
337 rm -f "$GIT_DIR/TMP_ALT"
338 fi
339 rsync_slurped_objects=t
340 }
341 ;;
342 *)
343 # We will do git native transport with just one call later.
344 continue ;;
345 esac
Junio C Hamano853a3692005-08-20 02:54:34 -0700346
Junio C Hamano03febf92006-01-07 00:48:04 -0800347 append_fetch_head "$head" "$remote" \
348 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
Junio C Hamano853a3692005-08-20 02:54:34 -0700349
Junio C Hamano03febf92006-01-07 00:48:04 -0800350 done
351
352 case "$remote" in
353 http://* | https://* | rsync://* )
354 ;; # we are already done.
355 *)
356 ( : subshell because we muck with IFS
357 IFS=" $LF"
358 (
Junio C Hamano482faa82006-07-17 13:01:27 -0700359 git-fetch-pack $exec $keep "$remote" $rref || echo failed "$remote"
Junio C Hamano03febf92006-01-07 00:48:04 -0800360 ) |
361 while read sha1 remote_name
362 do
363 case "$sha1" in
364 failed)
365 echo >&2 "Fetch failure: $remote"
366 exit 1 ;;
367 esac
368 found=
369 single_force=
370 for ref in $refs
371 do
372 case "$ref" in
373 +$remote_name:*)
374 single_force=t
375 not_for_merge=
376 found="$ref"
377 break ;;
378 .+$remote_name:*)
379 single_force=t
380 not_for_merge=t
381 found="$ref"
382 break ;;
383 .$remote_name:*)
384 not_for_merge=t
385 found="$ref"
386 break ;;
387 $remote_name:*)
388 not_for_merge=
389 found="$ref"
390 break ;;
391 esac
392 done
Mark Woodingf327dbc2006-04-13 22:01:24 +0000393 local_name=$(expr "z$found" : 'z[^:]*:\(.*\)')
Junio C Hamano03febf92006-01-07 00:48:04 -0800394 append_fetch_head "$sha1" "$remote" \
395 "$remote_name" "$remote_nick" "$local_name" "$not_for_merge"
396 done
397 ) || exit ;;
398 esac
399
400}
401
402fetch_main "$reflist"
403
404# automated tag following
405case "$no_tags$tags" in
406'')
Junio C Hamano6dc78e62006-02-22 13:10:37 -0800407 case "$reflist" in
408 *:refs/*)
409 # effective only when we are following remote branch
410 # using local tracking branch.
411 taglist=$(IFS=" " &&
412 git-ls-remote $upload_pack --tags "$remote" |
413 sed -ne 's|^\([0-9a-f]*\)[ ]\(refs/tags/.*\)^{}$|\1 \2|p' |
414 while read sha1 name
415 do
416 test -f "$GIT_DIR/$name" && continue
417 git-check-ref-format "$name" || {
418 echo >&2 "warning: tag ${name} ignored"
419 continue
420 }
421 git-cat-file -t "$sha1" >/dev/null 2>&1 || continue
422 echo >&2 "Auto-following $name"
423 echo ".${name}:${name}"
424 done)
425 esac
Junio C Hamano03febf92006-01-07 00:48:04 -0800426 case "$taglist" in
427 '') ;;
428 ?*)
429 fetch_main "$taglist" ;;
430 esac
Junio C Hamano853a3692005-08-20 02:54:34 -0700431esac
Junio C Hamanob10ac502005-08-25 18:15:32 -0700432
433# If the original head was empty (i.e. no "master" yet), or
434# if we were told not to worry, we do not have to check.
435case ",$update_head_ok,$orig_head," in
436*,, | t,* )
437 ;;
438*)
Junio C Hamanobf7960e2005-09-27 18:14:27 -0700439 curr_head=$(git-rev-parse --verify HEAD 2>/dev/null)
Junio C Hamanob10ac502005-08-25 18:15:32 -0700440 if test "$curr_head" != "$orig_head"
441 then
Shawn Pearce55b78352006-07-10 23:38:35 -0400442 git-update-ref \
443 -m "$rloga: Undoing incorrectly fetched HEAD." \
444 HEAD "$orig_head"
Junio C Hamanob10ac502005-08-25 18:15:32 -0700445 die "Cannot fetch into the current branch."
446 fi
447 ;;
448esac